VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsModifyUser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

Dim DQC                                As DiskQuotaControl
Dim DQU                                As DIDiskQuotaUser

Implements IDiskQuotaControlEvents

Public Function ModUser(ByVal DriveName As String, _
                        ByVal DSNDriveName As String, _
                        ByVal UserInfo As clsUsers) As Boolean
   Dim p_strResolution                 As String
   Dim p_strQuotaState                 As String
   Dim p_strSID                        As String
   Dim p_lngLimit                      As Long
   Dim p_dblLimit                      As Double
   
   Set DQC = New DiskQuotaControl
   
   If Right$(DriveName, 1) <> "\" Then
      DriveName = DriveName & "\"
   End If
   
   DQC.Initialize DriveName, True
   
   p_strSID = DQC.TranslateLogonNameToSID(UserInfo.LogonName)
   
   On Error Resume Next
   Set DQU = DQC.FindUser(LogonName:=p_strSID)
   If Err.Number <> 0 Then
      Set DQU = DQC.AddUser(LogonName:=p_strSID)
   End If
   'Set DQU = DQC.AddUser(LogonName:=UserInfo.ADsPath)
   
   p_dblLimit = UserInfo.QuotaLimit * (1024# * 1024#)
   DQU.QuotaLimit = p_dblLimit
   
   p_dblLimit = UserInfo.WarningLevel * (1024# * 1024#)
   DQU.QuotaThreshold = p_dblLimit
   
   DQU.Invalidate
   
End Function

Private Sub IDiskQuotaControlEvents_OnUserNameChanged(ByVal pUser As DiskQuotaTypeLibrary.DIDiskQuotaUser)
   MsgBox "User: " & pUser.LogonName & vbCrLf & _
          "Quota Limit: " & pUser.QuotaLimitText & vbCrLf & _
          "Quota Used: " & pUser.QuotaUsedText
End Sub


