Attribute VB_Name = "modQuota"
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

Dim DQC                                As DiskQuotaControl

Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long

Public Function IsNTFS(ByVal xi_strFilePath As String) As Boolean
   Dim p_strVolBuffer                  As String
   Dim p_strSystemName                 As String
   Dim p_strVol                        As String
   Dim p_lngSerialNum                  As Long
   Dim p_lngSystemFlags                As Long
   Dim p_lngComponentLen               As Long
   Dim p_lngRtn                        As Long
   
   IsNTFS = False
   
   p_strVolBuffer = String$(256, 0)
   p_strSystemName = String$(256, 0)
   p_strVol = Trim$(UCase$(Mid$(xi_strFilePath, 1, 3)))
   If Right$(p_strVol, 1) <> "\" Then
      p_strVol = p_strVol & "\"
   End If
   
   p_lngRtn = GetVolumeInformation(p_strVol, _
                                   p_strVolBuffer, _
                                   Len(p_strVolBuffer) - 1, _
                                   p_lngSerialNum, _
                                   p_lngComponentLen, _
                                   p_lngSystemFlags, _
                                   p_strSystemName, _
                                   Len(p_strSystemName) - 1)
   If p_lngRtn <> 0 Then
      If UCase$(Mid$(p_strSystemName, 1, 4)) = "NTFS" Then
         IsNTFS = True
      Else
         IsNTFS = False
      End If
   Else
      MsgBox modApi_Err.ReturnApiErrString(Err.LastDllError)
   End If

End Function

Public Function SystemDefaults(ByVal xi_strDriveName As String) As DiskQuotaControl
   Dim p_strResolution                 As String
   Dim p_strQuotaState                 As String
   
   Set DQC = New DiskQuotaControl
   
   frmQuota.lblDrive = xi_strDriveName
   
   If Right$(xi_strDriveName, 1) <> "\" Then
      xi_strDriveName = xi_strDriveName & "\"
   End If
   
   DQC.Initialize xi_strDriveName, True
   
   frmQuota.txtQuotaLimit.Text = DQC.DefaultQuotaLimit / 1024& / 1024&
   
   frmQuota.txtQuotaThreshold.Text = DQC.DefaultQuotaThreshold / 1024& / 1024&
   
   If DQC.LogQuotaLimit = True Then
      frmQuota.chkLogQuotaLimits.Value = vbChecked
   Else
      frmQuota.chkLogQuotaLimits.Value = vbUnchecked
   End If
   
   If DQC.LogQuotaThreshold = True Then
      frmQuota.chkLogQuotaThreshold.Value = vbChecked
   Else
      frmQuota.chkLogQuotaThreshold.Value = vbUnchecked
   End If
   
   If DQC.QuotaFileIncomplete = True Then
      frmQuota.lblQuotaFileIncomplete(0).Visible = True
      frmQuota.lblQuotaFileIncomplete(1).Visible = False
   Else
      frmQuota.lblQuotaFileIncomplete(0).Visible = False
      frmQuota.lblQuotaFileIncomplete(1).Visible = True
   End If
   
   If DQC.QuotaFileRebuilding = True Then
      frmQuota.lblQuotaFileRebuilding(0).Visible = True
      frmQuota.lblQuotaFileRebuilding(1).Visible = False
   Else
      frmQuota.lblQuotaFileRebuilding(0).Visible = False
      frmQuota.lblQuotaFileRebuilding(1).Visible = True
   End If
   
   Select Case DQC.QuotaState
       Case dqStateDisable
         p_strQuotaState = "Disk Quotas Disabled"
      Case dqStateEnforce
         p_strQuotaState = "Disk Quotas Enforced"
      Case dqStateTrack
         p_strQuotaState = "Disk Quotas Tracked"
      Case Else
         p_strQuotaState = "Unknown"
   End Select
   frmQuota.cboQuotaState.Text = p_strQuotaState
   
   Select Case DQC.UserNameResolution
      Case dqResolveNone
         p_strResolution = "None"
      Case dqResolveAsync
         p_strResolution = "Resolve Asynchronously"
      Case dqResolveSync
         p_strResolution = "Resolve Snychronously"
      Case Else
         p_strResolution = "Unknown"
   End Select
   frmQuota.cboNameResolution.Text = p_strResolution
   
   Set SystemDefaults = DQC
   
End Function

Public Sub Main()
   frmQuota.Show vbModeless
End Sub
