VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "colUsers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsUsers"
Attribute VB_Ext_KEY = "Member0" ,"clsUsers"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

Dim DQC                                As DiskQuotaControl
Dim DQU                                As DIDiskQuotaUser

Private m_strDomainName                As String
Private m_strDriveName                 As String
Private m_strDNSName                   As String
Private m_strStatus                    As String
Private m_strLogonName                 As String
Private m_lngQuotaUsed                 As Long
Private m_lngQuotaLimit                As Long
Private m_lngQuotaThreshold            As Long
Private m_sngPercentUsed               As Single
Private m_lngUserID                    As Long
Private m_blnIsRebuilding              As Boolean

' --------------------------------------------
'
' --------------------------------------------
Private m_enmStatusEnum                As enmStatusEnum

Public Enum enmStatusEnum
   dqAcctResolved = 0
   dqAcctUnavailable = 1
   dqAcctDeleted = 2
   dqAcctInvalid = 3
   dqAcctUnknown = 4
   dqAcctUnresolved = 5
End Enum

' --------------------------------------------
'
' --------------------------------------------
Private m_lngIndex                     As Long

' --------------------------------------------
' Local variable to hold collection
' --------------------------------------------
Private m_colUsers                     As Collection

Public Sub Clear()
On Error Resume Next                   ' Don't accept an error here
   Set m_colUsers = Nothing
   Set m_colUsers = New Collection
   m_lngIndex = 0
On Error GoTo 0
End Sub

Public Sub Init(ByVal DomainName As String, _
                ByVal DriveName As String, _
                ByVal DNSName As String)
   
   m_strDomainName = DomainName
   m_strDriveName = DriveName
   m_strDNSName = DNSName
   
   GetUsers
   
End Sub

Private Sub GetUsers()
   Dim p_objADsContainer               As IADsContainer
   Dim p_objADsChild                   As IADs
   
   Set p_objADsContainer = GetObject("WinNT://" & m_strDomainName)
   'Set p_objADsContainer = GetObject(m_strDNSName)
   For Each p_objADsChild In p_objADsContainer
      If UCase$(p_objADsChild.Class) = "USER" Then
         Add Name:=p_objADsChild.Name, _
             Guid:=p_objADsChild.Guid, _
             ADsPath:=p_objADsChild.ADsPath, _
             DomainName:=m_strDomainName
      End If
   Next p_objADsChild
   
End Sub

Public Property Get IsRebuilding() As Boolean
   IsRebuilding = m_blnIsRebuilding
End Property

Private Sub ExtraInfo(ByVal xi_strFullUserName As String)
   Dim p_strSID                        As String
   
   Set DQC = New DiskQuotaControl
   m_strLogonName = xi_strFullUserName
   
   frmQuota.lblDrive = m_strDriveName
   
   If Right$(m_strDriveName, 1) <> "\" Then
      m_strDriveName = m_strDriveName & "\"
   End If
   
   DQC.Initialize m_strDriveName, True

   m_blnIsRebuilding = DQC.QuotaFileRebuilding
   If m_blnIsRebuilding = True Then
      Debug.Print
   End If
   
   On Error Resume Next
   p_strSID = DQC.TranslateLogonNameToSID(xi_strFullUserName)
   Set DQU = DQC.FindUser(LogonName:=p_strSID)
   If Err.Number <> 0 Then
      Set DQU = DQC.FindUser(LogonName:=xi_strFullUserName)
      If Err.Number <> 0 Then
         m_lngQuotaUsed = 0
         m_lngQuotaLimit = 0
         m_lngQuotaThreshold = 0
         m_sngPercentUsed = 0
         m_strStatus = "UNKNOWN"
         m_lngUserID = 0
         m_enmStatusEnum = dqAcctUnknown
      Else
         m_lngQuotaUsed = DQU.QuotaUsed / 1024& / 1024&
         m_lngQuotaLimit = DQU.QuotaLimit / 1024& / 1024&
         m_lngQuotaThreshold = DQU.QuotaThreshold / 1024& / 1024&
         
         If m_lngQuotaLimit > 0 Then
            If m_lngQuotaUsed <= m_lngQuotaLimit Then
               m_sngPercentUsed = m_lngQuotaUsed / m_lngQuotaLimit
               m_strStatus = "OK"
            Else
               m_sngPercentUsed = 100
               m_strStatus = "Warning"
            End If
         Else
            m_sngPercentUsed = 0
            m_strStatus = "UNKNOWN"
         End If
      
         m_lngUserID = DQU.ID
         m_enmStatusEnum = DQU.AccountStatus
      End If
   Else
      m_lngQuotaUsed = DQU.QuotaUsed / 1024& / 1024&
      m_lngQuotaLimit = DQU.QuotaLimit / 1024& / 1024&
      m_lngQuotaThreshold = DQU.QuotaThreshold / 1024& / 1024&
      
      If m_lngQuotaLimit > 0 Then
         If m_lngQuotaUsed <= m_lngQuotaLimit Then
            m_sngPercentUsed = m_lngQuotaUsed / m_lngQuotaLimit
            m_strStatus = "OK"
         Else
            m_sngPercentUsed = 100
            m_strStatus = "Warning"
         End If
      Else
         m_sngPercentUsed = 0
         m_strStatus = "UNKNOWN"
      End If
   
      m_lngUserID = DQU.ID
      m_enmStatusEnum = DQU.AccountStatus
   End If
   
   m_lngIndex = m_lngIndex + 1
   
End Sub

Private Sub Add(ByVal Name As String, _
                ByVal Guid As Variant, _
                ByVal ADsPath As String, _
                ByVal DomainName As String)
   Dim p_objUser                       As clsUsers
   
   ' ------------------------------------------
   ' Create a temp local copy of new collection
   '     item
   ' ------------------------------------------
   Set p_objUser = New clsUsers
   
   ' ------------------------------------------
   '
   ' ------------------------------------------
   ExtraInfo xi_strFullUserName:=DomainName & "\" & Name
   
   ' ------------------------------------------
   ' Use the Init() method on the collection item
   '     to set the properties passed into the method
   ' ------------------------------------------
   p_objUser.Init Guid:=Guid, _
                  Name:=Name, _
                  ADsPath:=ADsPath, _
                  DomainName:=DomainName, _
                  LogonName:=m_strLogonName, _
                  Status:=m_strStatus, _
                  QuotaLimit:=m_lngQuotaLimit, _
                  AmountUsed:=m_lngQuotaUsed, _
                  WarningLevel:=m_lngQuotaThreshold, _
                  PercentUsed:=m_sngPercentUsed, _
                  ID:=m_lngUserID, _
                  Index:="USR_" & CStr(m_lngIndex), _
                  StatusEnum:=m_enmStatusEnum
                  
   ' ------------------------------------------
   ' Add the object to the class-level collection
   ' ------------------------------------------
   m_colUsers.Add Item:=p_objUser, _
                  Key:="USR_" & CStr(m_lngIndex)
   
   ' ------------------------------------------
   ' Clear the temporary object (it's now
   '     stored in the collection)
   ' ------------------------------------------
   Set p_objUser = Nothing

End Sub

Public Property Get Item(ByVal IndexKey As Variant) As clsUsers
Attribute Item.VB_UserMemId = 0
   Set Item = m_colUsers(IndexKey)
End Property

Public Property Get Count() As Long
   Count = m_colUsers.Count
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
   Set NewEnum = m_colUsers.[_NewEnum]
End Property

Private Sub Class_Initialize()
On Error Resume Next                   ' Don't accept an error here
   Set m_colUsers = New Collection
   m_lngIndex = 0
On Error GoTo 0
End Sub

Private Sub Class_Terminate()
On Error Resume Next                   ' Don't accept an error here
   Set m_colUsers = Nothing
On Error GoTo 0
End Sub

